<template>
  <page
    class="flex-grow-1"
    id="station-data-page"
    v-if="station"
    :title="`Leitor ${station.node}`"
  >
    <v-divider />
    <v-subheader>Histórico</v-subheader>
    <v-timeline
      class="mb-5"
      dense="dense"
    >
      <v-timeline-item
        v-for="event in events"
        :key="event.id"
        :color="typeInfo(event).color"
      >
        <v-list-item
          justify="space-between"
          :to="typeInfo(event).to"
        >
          <v-list-item-content>
            <v-list-item-title>{{typeInfo(event).msg}}</v-list-item-title>
          </v-list-item-content>
          <v-col class="text-right">{{timeFromISO(event.created)}}</v-col>
        </v-list-item>
      </v-timeline-item>
    </v-timeline>
  </page>
</template>

<script>
import Page from '@/components/Page.vue'
import { DateTime } from 'luxon'

import stationInfoQuery from '@/gql/StationInfo.gql'
import stationInfoSubscription from '@/gql/StationInfoSubscription.gql'

export default {
  name: 'StationPage',
  components: { Page },
  data: () => ({}),
  computed: {
    id () {
      return this.$route.params.id
    },
    events () {
      const reversed = this.station.events.slice()
      reversed.reverse()
      return reversed
    }
  },
  apollo: {
    station: {
      query: stationInfoQuery,
      variables () {
        return {
          id: this.id
        }
      },
      skip () {
        return !this.id
      },
      subscribeToMore: {
        document: stationInfoSubscription,
        variables () {
          return {
            id: this.id
          }
        },
        skip () {
          return !this.id
        }
      }
    }
  },
  methods: {
    typeInfo (event) {
      switch (event.type) {
        case 'CREATED':
          return { msg: 'Estação registrada', color: 'success' }
        case 'ASSOCIATED':
          return {
            msg: `'${event.entity && event.entity.fullname}' associado`
          }
        case 'CARD_READ':
          return {
            msg: `Cartão ${event.data &&
              event.data.card &&
              event.data.card.code}`,
            to: {
              name: 'card',
              params: {
                id: event.data && event.data.card && event.data.card.id
              }
            }
          }
      }
    },
    timeFromISO (time) {
      return DateTime.fromISO(time).toFormat('dd/MM/yyyy - TT')
    }
  }
}
</script>
